class EigenschaftsController < ApplicationController
  
  def new
    eigens(0) 
    @eigens.name          = 'neu'
    @eigens.beschreibung  = 'neue Eigenschaft'
    @eigens.id            = 0
    render :action        => 'edit'
  end  
  
  def list
    view_tree('Eigen')
    render :template => "application/index"
  end
  
  def edit_called_by_tree
    eigens(params[:idnr])
    render :action  => 'edit'
  end
  
  def update
    eigens(params[:id])    
    if params[:todo]
      @eigens.destroy
      view_tree("Eigen", "", "clear")
      @info          = ['hinweis', 'main']
      flash[:notice] = 'Der Satz wurde erfolgreich gelscht'
      redirect_to :action => 'index', :controller => 'application'
    else
      do_save
      render :action  => 'edit'   
    end 
  end

  # <b>art</b> prft das Feld "art"
  
  def art
    idnr      = params[:idnr] ? params[:idnr] : 0
    list_key  = params[:input]
    if idnr.to_i > 0              # nur bei vorhandenen Stzen erforderlich
      eigens(params[:idnr]) 
      @eigens.check = {'art', params[:input]}
      unless @eigens.valid?
        flash[:notice]  = @eigens.errors.on('art') 
        @html_flash     = @eigens.errors.count > 0 ? "<div class=\"popup_error\">#{flash[:notice]}</div>" : ""
        list_key        = @eigens.art
      end
    end      
    render :partial => "application/list",
                        :locals => {
		                    :liste => 'EigenArt', :listKey => list_key,
		                    :act => 'art', :cont => 'eigenschafts', :idnr => idnr
		                    }
  end   

  # <b>dropped</b> bearbeitet den Drag-Drop-Vorgang

  def dropped
    dropped             = params[:dropped] ? params[:dropped] : 0
    if dropped.to_i > 0    
      eigens(params[:idnr]) 
      @eigens.check     = {'gruppeneigenschaft', params[:dropped]} 
      if @new || @eigens.valid?
        @dropdrag       = params[:dropped] 
      else
        flash[:notice]  = @eigens.errors.on('gruppeneigenschaft') 
        @html_flash     = @eigens.errors.count > 0 ? "<div class=\"popup_error\">#{flash[:notice]}</div>" : ""
        @dropdrag       = @eigens.gruppeneigenschaft
      end
      gruppe          = Eigenschafts.find(@dropdrag)
    end
    render :partial   => 'application/dropdrag',
                        :locals => {
		                    :show => gruppe.name,
		                    :tooltip => "Um die Gruppeneigenschaft zu &auml;ndern, einfach dieses Icon auf die neue Eigenschaft ziehen",
		                    :act => 'dropped', :cont => 'eigenschafts'
		                    }   
  end
 
  ######################################################################################################    
  
  private
  
  # <b>do_save</b> fhrt die Prfungen und Aktualisierungen fr update und new aus
  
  def do_save
    dropped         = @template.dropdrag(params[:id])
    name            = @eigens.name
    gruppe          = @eigens.gruppeneigenschaft
    @eigens.check   = {'art' => params[:idList], 'gruppeneigenschaft' => dropped}
    params[:eigens][:art]  = Liste.new('EigenArt', params[:idList]).key
    params[:eigens][:gruppeneigenschaft] = dropped
    if @eigens.update_attributes(params[:eigens])
      info                  = ['hinweis', 'main']
      notice                = 'Der Datensatz wurde erfolgreich gespeichert.'
    else      
      info, notice, msg     = ['error', 'main'], "", []
      @eigens.errors.each {|attr, msg| notice << "#{msg}<br>"}  
    end
    @dropdrag         = @eigens.gruppeneigenschaft        # Aktualisierung der Instanzvariablen
    unless gruppe == @eigens.gruppeneigenschaft && !@new && name == @eigens.name
      view_tree("Eigen", "", "clear")
    end
    @info           = info
    flash[:notice]  = notice
  end

  def eigens(id)
    if id.to_i > 0
      @eigens         = Eigenschafts.find(id)
    else
      @eigens         = Eigenschafts.new    
    end
    @dropdrag         = @eigens.gruppeneigenschaft
    @new = @eigens.new_record? ? true : false     
  end
  
end
