
class Eigenschafts < ActiveRecord::Base
  acts_as_tree :foreign_key => 'gruppeneigenschaft'

  include Models_modul
 
  # Standard-Validierungen
  
  validates_presence_of :beschreibung
 
  ######################################################################################################    
  
  private  
     
  def art_ok?(check)         # alle Felder sind als Methoden bereits angelegt: Der Call darauf gibt den Feldwert zurck
    listKey = Liste.new('EigenArt', check).key
    unless listKey == self.art || self.verwendung.empty? 
      @errors.add("art", "Die Art \"#{self.art}\" kann nicht geändert werden, solange die Eigenschaft verwendet wird") 
    end
  end
  
  def gruppeneigenschaft_ok?(check)
    if self.id == check.to_i
      @errors.add("gruppeneigenschaft", "Die Eigenschaft \"#{self.name}\" darf sich nicht selbst als Gruppeneigenschaft haben") 
    end   
  end
      
end     # class
